with Strings;
use Strings;

pragma Elaborate_All (Strings);

package body Params is

  procedure Set_Defaults(P: out Param) is
  begin
    P.Prefix  := "NULL";
    P.Map     := 0;
    P.Alpha   := 0/1;
    P.BetaI   := 0;
    P.BetaJ   := 1;
    P.FDeg    := 0;
    P.Size    := 1;
    P.Rho1    := One;
    P.Rho2    := One;
    P.RefPhi  := 0;
    P.RefTh   := 0;
    P.Symm    := 0;
    P.Mixed   := False;
    P.Par     := 0;
    P.FreqPar := 0;
    P.Mat_PackCSize   := 0;
    P.Contr_PackCSize := 0;
    P.Mat_PackSSize   := 0;
    P.Contr_PackSSize := 0;
  end Set_Defaults;

  procedure Show(N: in String; P: in Param) is
  begin
    Show0(N & "         Prefix: " & P.Prefix);
    Show1(N & "            Map: ",P.Map);
    Show1(N & "          Alpha: ",P.Alpha);
    Show1(N & "          BetaI: ",P.BetaI);
    Show1(N & "          BetaJ: ",P.BetaJ);
    Show1(N & "           FDeg: ",P.FDeg);
    Show1(N & "           Size: ",P.Size);
    Show1(N & "           Rho1: ",P.Rho1);
    Show1(N & "           Rho2: ",P.Rho2);
    Show1(N & "         RefPhi: ",P.RefPhi);
    Show1(N & "          RefTh: ",P.RefTh);
    Show1(N & "           Symm: ",P.Symm);
    Show1(N & "          Mixed: ",P.Mixed);
    Show1(N & "            Par: ",P.Par);
    Show1(N & "        FreqPar: ",P.FreqPar);
    Show1(N & "  Mat_PackCSize: ",P.Mat_PackCSize);
    Show1(N & "Contr_PackCSize: ",P.Contr_PackCSize);
    Show1(N & "  Mat_PackSSize: ",P.Mat_PackSSize);
    Show1(N & "Contr_PackSSize: ",P.Contr_PackSSize);
  end Show;

  function Left_Part(S: String; L: Positive) return String is
    T: String(1 .. L) := (others => ' ');
    C: Character;
    J: Integer := 0;
  begin
    for I in S'Range loop
      C := S(I);
      if C/=' ' then
        J := J+1;
        T(J) := C;
        exit when J=L;
      end if;
    end loop;
    return T;
  end Left_Part;

  function IndexOf(S: String) return Natural is
    T: constant String4 := Left_Part(S,4);
  begin
    for I in PList'Range loop
      if T=PList(I).Prefix then return I; end if;
    end loop;
    return 0;
  end IndexOf;

end Params;
