with Globals, Ints, Strings, Params, Flts, Ints, Rationals;
use Globals, Ints, Strings, Params, Flts, Ints, Rationals;
with Approx_Fixpt,Check_FixPt;

pragma Elaborate_All (Globals,Ints,Strings,Approx_Fixpt,Check_FixPt);

procedure Run_All is

   NT:   constant Positive := GetArg;      --- number of concurrent tasks
   Filename: constant String := GetArg;
   Sol:  constant Natural  := IndexOf(Filename);

   procedure Run(I: Natural) is
      P: Param := PList(I);
   begin
      Show1("PList entry ",I);
      Approx_Fixpt(P);
      Show0("Approx_Fixpt done");
      if P.Contr_PackSSize>0 then
         Check_Fixpt(P);
         Show0("Check_Fixpt done");
      end if;
      Show0("--------------------------------");
   end Run;

   PP: Param := PList(Sol);

begin

   Verbosity := 2;
   NTasks := NT;

   if Sol>0 then
      Run(Sol);
   else
      for I in 1..PList'Last loop Run(I); end loop;
   end if;

end Run_All;
